<?php

class Quivers_Integration_Model_Order extends Mage_Sales_Model_Order
{
	    /**
     * Check for order status in Quivers and validate
     *  the possibility to unhold the order.
     *
     * @return Mage_Sales_Model_Order
     * @throws Mage_Core_Exception
     */

    public function validate_order_status_for_unhold()
    {
    	$quiversAPIKey = Mage::getStoreConfig('quivers_integration/settings/quivers_api_key');
        $quiversSandbox = Mage::getStoreConfig('quivers_integration/settings/quivers_sandbox_enabled');
        $orderUpdateValidateUrl = 'https://konect.quiverstest.com/clients/validate/order/';
        if($quiversSandbox == 0) {
            $orderUpdateValidateUrl = "https://konect.quivers.com/clients/validate/order/";
        }

        $payload = array(
        	'client_type'=> 'MAGENTO1',
        	'order_number'=> $this->getIncrementId(),
        	);

        // Mage::log($payload);
        $ch = curl_init($orderUpdateValidateUrl);
        # Setup request to send json via POST.
        $orderData = json_encode($payload);
        curl_setopt( $ch, CURLOPT_POSTFIELDS, $orderData);
        curl_setopt( $ch, CURLOPT_HTTPHEADER, array(
        	'Content-Type:application/json',
        	'Authorization: apikey '.$quiversAPIKey
        	)
        );

        # Return response instead of printing.
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
        # Send request.
        $result = curl_exec($ch);
        $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);
        if($httpcode!=200) {
        	Mage::throwException(Mage::helper('sales')->__('Unhold action is not available.'));
        }

        $responseDecoded = json_decode($result, true);
        foreach ($responseDecoded as $key => $item) {
        	if( $item['Value'] == 60 && $item['performed_by'] == 'Retailer' ) {
				Mage::throwException(Mage::helper('sales')->__('Unhold action is not available. This order is already shipped by a Retailer'));        		
        	}
        }
    }
}
