<?php
class Quivers_Integration_Model_SettingObserver
{

    const XML_MARKETPLACE_ID = 'quivers_integration/settings/quivers_marketplace_id';
    const XML_CLAMING_GROUP_ID = 'quivers_integration/settings/quivers_claiming_group_id';
    const XML_QUIVERS_API_KEY = 'quivers_integration/settings/quivers_api_key';
    const XML_QUIVERS_BUSINESS_REFID = 'quivers_integration/settings/quivers_business_ref_id';
    const XML_MAGNETO_AUTH_USER = 'quivers_integration/settings/magento_integration_auth_user';
    const XML_MAGENTO_ACCESS_TOKEN = 'quivers_integration/settings/magento_integration_access_token';
    const XML_MAGENTO_BASE_URL = 'quivers_integration/settings/magento_integration_base_url';
    const XML_QUIVERS_SANDBOX = 'quivers_integration/settings/quivers_sandbox_enabled';

    protected $profileUrl = 'https://konect.quiverstest.com/clients/profile/';

    public function settingUpdate($observer)
    {
        Mage::log("updating middleware settings");

        $marketPlaceId = Mage::getStoreConfig('quivers_integration/settings/quivers_marketplace_id');
        $productGroupId = Mage::getStoreConfig('quivers_integration/settings/quivers_claiming_group_id');
        $quiversAPIKey = Mage::getStoreConfig('quivers_integration/settings/quivers_api_key');
        $magentoBaseUrl = Mage::getStoreConfig('quivers_integration/settings/magento_integration_base_url');
        $quiversSandbox = Mage::getStoreConfig('quivers_integration/settings/quivers_sandbox_enabled');
        $quiversBusinessRefId = Mage::getStoreConfig('quivers_integration/settings/quivers_business_ref_id');
        $magentoAcessToken = Mage::getStoreConfig('quivers_integration/settings/magento_integration_access_token');
        $magentoAuthUser = Mage::getStoreConfig('quivers_integration/settings/magento_integration_auth_user');

        if($quiversSandbox == 0) {
            $this->profileUrl = "https://konect.quivers.com/clients/profile/";
        }

        $payload = array(
            "quivers_api_key" => "apikey ".$quiversAPIKey,
            "merchant_ref_id" => $quiversBusinessRefId,
            "quivers_extra_data" => array(
                "ProductGroupId" => $productGroupId,
                "marketplaceId" => $marketPlaceId
            ),
            "client_type" => "MAGENTO1",
            "client_auth_object" => array(
                "auth_token" => $magentoAcessToken,
                "auth_user" => $magentoAuthUser
            ),
            "client_extra_data" => array(
                "base_url" => $magentoBaseUrl
            ),
            'relay_orders_to_quivers' => true
        );

        try {
            // Mage::log($payload);
            $ch = curl_init($this->profileUrl);
            # Setup request to send json via POST.
            $profileData = json_encode($payload);
            curl_setopt( $ch, CURLOPT_POSTFIELDS, $profileData );
            curl_setopt( $ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
            # Return response instead of printing.
            curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
            # Send request.
            $result = curl_exec($ch);
            $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            curl_close($ch);
            // Mage::log($httpcode);
            // Mage::log($result);
            if($httpcode!=201) {
                $errorMessage = 'An error occurred on the server. ERROR: '.$result;
                Mage::log($errorMessage);
                Mage::throwException($errorMessage);
            }
        } catch (Exception $e) {
            Mage::throwException(__('Error syncing setting with Quivers'));
        }

        return $this;
    }
}